searchData={"content_type":"text/markdown","items":[{"doc":"Microsoft SQL Server driver for Elixir.\n\nTds is partial implementation of the Micorosoft SQL Server\n[MS-TDS](https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-tds)\nTabular Data Stream Protocol.\n\nA Tds query is performed in separate server-side prepare and execute stages.\n\nAt the moment query handle is not reused, but there is plan to cahce handles in\nnear feature. It uses [RPC](https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-tds/619c43b6-9495-4a58-9e49-a4950db245b3)\nrequests by default to `Sp_Prepare` (ProcId=11) and `Sp_Execute` (ProcId=12)\nquery, but it is possible to configure driver to use only Sp_ExecuteSql.\n\nPlease consult with [configuration](readme.html#configuration) how to do this.","ref":"Tds.html","title":"Tds","type":"module"},{"doc":"","ref":"Tds.html#child_spec/1","title":"Tds.child_spec/1","type":"function"},{"doc":"","ref":"Tds.html#close/3","title":"Tds.close/3","type":"function"},{"doc":"","ref":"Tds.html#close!/3","title":"Tds.close!/3","type":"function"},{"doc":"Decodes MS uniqueidentifier binary to its string representation.","ref":"Tds.html#decode_uuid/1","title":"Tds.decode_uuid/1","type":"function"},{"doc":"Same as `decode_uuid/1` but raises `ArgumentError` if value is invalid.","ref":"Tds.html#decode_uuid!/1","title":"Tds.decode_uuid!/1","type":"function"},{"doc":"Encodes UUID string into MS uniqueidentifier binary.","ref":"Tds.html#encode_uuid/1","title":"Tds.encode_uuid/1","type":"function"},{"doc":"Same as `encode_uuid/1` but raises `ArgumentError` if value is invalid.","ref":"Tds.html#encode_uuid!/1","title":"Tds.encode_uuid!/1","type":"function"},{"doc":"","ref":"Tds.html#execute/4","title":"Tds.execute/4","type":"function"},{"doc":"","ref":"Tds.html#execute!/4","title":"Tds.execute!/4","type":"function"},{"doc":"Generates a version 4 (random) UUID in the MS uniqueidentifier binary format.","ref":"Tds.html#generate_uuid/0","title":"Tds.generate_uuid/0","type":"function"},{"doc":"Returns the configured JSON library.\n\nTo customize the JSON library, include the following in your `config/config.exs`:\n\n    config :tds, json_library: SomeJSONModule\n\nDefaults to `Jason`.","ref":"Tds.html#json_library/0","title":"Tds.json_library/0","type":"function"},{"doc":"","ref":"Tds.html#prepare/3","title":"Tds.prepare/3","type":"function"},{"doc":"","ref":"Tds.html#prepare!/3","title":"Tds.prepare!/3","type":"function"},{"doc":"","ref":"Tds.html#query/4","title":"Tds.query/4","type":"function"},{"doc":"","ref":"Tds.html#query!/4","title":"Tds.query!/4","type":"function"},{"doc":"Executes statement that can contain multiple SQL batches, result will contain\nall results that server yield for each batch.","ref":"Tds.html#query_multi/4","title":"Tds.query_multi/4","type":"function"},{"doc":"","ref":"Tds.html#rollback/2","title":"Tds.rollback/2","type":"function"},{"doc":"","ref":"Tds.html#start_link/1","title":"Tds.start_link/1","type":"function"},{"doc":"","ref":"Tds.html#transaction/3","title":"Tds.transaction/3","type":"function"},{"doc":"","ref":"Tds.html#t:conn/0","title":"Tds.conn/0","type":"type"},{"doc":"","ref":"Tds.html#t:execute_option/0","title":"Tds.execute_option/0","type":"type"},{"doc":"","ref":"Tds.html#t:isolation_level/0","title":"Tds.isolation_level/0","type":"type"},{"doc":"","ref":"Tds.html#t:option/0","title":"Tds.option/0","type":"type"},{"doc":"","ref":"Tds.html#t:resultset/0","title":"Tds.resultset/0","type":"type"},{"doc":"","ref":"Tds.html#t:start_option/0","title":"Tds.start_option/0","type":"type"},{"doc":"","ref":"Tds.html#t:transaction_option/0","title":"Tds.transaction_option/0","type":"type"},{"doc":"Default encoding for Tds","ref":"Tds.Encoding.Latin1.html","title":"Tds.Encoding.Latin1","type":"module"},{"doc":"","ref":"Tds.Encoding.Latin1.html#decode/2","title":"Tds.Encoding.Latin1.decode/2","type":"function"},{"doc":"","ref":"Tds.Encoding.Latin1.html#encode/2","title":"Tds.Encoding.Latin1.encode/2","type":"function"},{"doc":"Converting UTF-8 strings into UCS-2 (UTF16 Little Endian) strings\nused by the MSSQL Database","ref":"Tds.Encoding.UCS2.html","title":"Tds.Encoding.UCS2","type":"module"},{"doc":"Converts a UTF-8 string into UCS-2","ref":"Tds.Encoding.UCS2.html#from_string/1","title":"Tds.Encoding.UCS2.from_string/1","type":"function"},{"doc":"Converts a UCS-2 string into UTF-8","ref":"Tds.Encoding.UCS2.html#to_string/1","title":"Tds.Encoding.UCS2.to_string/1","type":"function"},{"doc":"Implements DBConnection behaviour for TDS protocol.","ref":"Tds.Protocol.html","title":"Tds.Protocol","type":"module"},{"doc":"","ref":"Tds.Protocol.html#checkin/1","title":"Tds.Protocol.checkin/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#checkout/1","title":"Tds.Protocol.checkout/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#connect/1","title":"Tds.Protocol.connect/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#disconnect/2","title":"Tds.Protocol.disconnect/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_begin/2","title":"Tds.Protocol.handle_begin/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_close/3","title":"Tds.Protocol.handle_close/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_commit/2","title":"Tds.Protocol.handle_commit/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_deallocate/4","title":"Tds.Protocol.handle_deallocate/4","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_declare/4","title":"Tds.Protocol.handle_declare/4","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_execute/4","title":"Tds.Protocol.handle_execute/4","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_fetch/4","title":"Tds.Protocol.handle_fetch/4","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_info/2","title":"Tds.Protocol.handle_info/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_prepare/3","title":"Tds.Protocol.handle_prepare/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_rollback/2","title":"Tds.Protocol.handle_rollback/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#handle_status/2","title":"Tds.Protocol.handle_status/2","type":"function"},{"doc":"","ref":"Tds.Protocol.html#login/1","title":"Tds.Protocol.login/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#message/3","title":"Tds.Protocol.message/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#ping/1","title":"Tds.Protocol.ping/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#send_close/3","title":"Tds.Protocol.send_close/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#send_prelogin/1","title":"Tds.Protocol.send_prelogin/1","type":"function"},{"doc":"","ref":"Tds.Protocol.html#send_prepare/3","title":"Tds.Protocol.send_prepare/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#send_transaction/3","title":"Tds.Protocol.send_transaction/3","type":"function"},{"doc":"","ref":"Tds.Protocol.html#t:env/0","title":"Tds.Protocol.env/0","type":"type"},{"doc":"","ref":"Tds.Protocol.html#t:packet_data/0","title":"Tds.Protocol.packet_data/0","type":"type"},{"doc":"","ref":"Tds.Protocol.html#t:sock/0","title":"Tds.Protocol.sock/0","type":"type"},{"doc":"","ref":"Tds.Protocol.html#t:state/0","title":"Tds.Protocol.state/0","type":"type"},{"doc":"","ref":"Tds.Protocol.html#t:t/0","title":"Tds.Protocol.t/0","type":"type"},{"doc":"","ref":"Tds.Protocol.html#t:transaction/0","title":"Tds.Protocol.transaction/0","type":"type"},{"doc":"Parses the column metadata from TDS response.","ref":"Tds.Protocol.ColMetadata.html","title":"Tds.Protocol.ColMetadata","type":"module"},{"doc":"","ref":"Tds.Protocol.ColMetadata.html#parse/1","title":"Tds.Protocol.ColMetadata.parse/1","type":"function"},{"doc":"","ref":"Tds.Protocol.ColMetadata.html#t:t/0","title":"Tds.Protocol.ColMetadata.t/0","type":"type"},{"doc":"The collation rule is used to specify collation information for character data\nor metadata describing character data.\n\nThis is typically specified as part of the LOGIN7 message or part of a column\ndefinition in server results containing character data.\n\nFor more information about column definition, see\nCOLMETADATA in MS-TDS.pdf.","ref":"Tds.Protocol.Collation.html","title":"Tds.Protocol.Collation","type":"module"},{"doc":"","ref":"Tds.Protocol.Collation.html#decode/1","title":"Tds.Protocol.Collation.decode/1","type":"function"},{"doc":"","ref":"Tds.Protocol.Collation.html#encode/1","title":"Tds.Protocol.Collation.encode/1","type":"function"},{"doc":"","ref":"Tds.Protocol.Collation.html#t:t/0","title":"Tds.Protocol.Collation.t/0","type":"type"},{"doc":"Grammar Definition for Token Description, General Rules.\n\nData structure encodings in TDS are defined in terms of the\nfundamental definitions.","ref":"Tds.Protocol.Grammar.html","title":"Tds.Protocol.Grammar","type":"module"},{"doc":"","ref":"Tds.Protocol.Grammar.html#bigbinary/1","title":"Tds.Protocol.Grammar.bigbinary/1","type":"macro"},{"doc":"A single bit value of either 0 or 1.","ref":"Tds.Protocol.Grammar.html#bit/1","title":"Tds.Protocol.Grammar.bit/1","type":"macro"},{"doc":"An unsigned single byte (8-bit) value.\n\nThe range is 0 to 255.","ref":"Tds.Protocol.Grammar.html#byte/1","title":"Tds.Protocol.Grammar.byte/1","type":"macro"},{"doc":"An unsigned single byte (8-bit) value representing the length of the\nassociated data.\n\nThe range is 0 to 255.","ref":"Tds.Protocol.Grammar.html#bytelen/0","title":"Tds.Protocol.Grammar.bytelen/0","type":"macro"},{"doc":"A 2-byte (16-bit) or 4-byte (32-bit) value representing a T-SQL NULL value\nfor a character or binary data type.\n\nPlease refer to TYPE_VARBYTE (see section 2.2.5.2.3 in MS-TDS.pdf)\nfor additional details.","ref":"Tds.Protocol.Grammar.html#charbin_null/1","title":"Tds.Protocol.Grammar.charbin_null/1","type":"macro"},{"doc":"An unsigned 4-byte (32-bit) value.\n\nThe range when used as a numeric value is 0 to (2^32)- 1.","ref":"Tds.Protocol.Grammar.html#dword/0","title":"Tds.Protocol.Grammar.dword/0","type":"macro"},{"doc":"A FRESERVEDBIT is a BIT value used for padding that does not transmit\ninformation.\n\nFRESERVEDBIT fields SHOULD be set to 0b0 and **MUST be ignored on receipt**.","ref":"Tds.Protocol.Grammar.html#freservedbit/1","title":"Tds.Protocol.Grammar.freservedbit/1","type":"macro"},{"doc":"A FRESERVEDBYTE is a BYTE value used for padding that does not transmit\ninformation.\n\nFRESERVEDBYTE fields SHOULD be set to 0x00 and **MUST be ignored on\nreceipt**.","ref":"Tds.Protocol.Grammar.html#freservedbyte/1","title":"Tds.Protocol.Grammar.freservedbyte/1","type":"macro"},{"doc":"A single byte (8-bit) value representing a NULL value.","ref":"Tds.Protocol.Grammar.html#gen_null/0","title":"Tds.Protocol.Grammar.gen_null/0","type":"macro"},{"doc":"A signed 4-byte (32-bit) value.\n\nThe range is -(2^31) to (2^31)-1.","ref":"Tds.Protocol.Grammar.html#long/0","title":"Tds.Protocol.Grammar.long/0","type":"macro"},{"doc":"A signed 4-byte (32-bit) value representing the length of the associated data.\n\nThe range is -(2^31) to (2^31)-1.","ref":"Tds.Protocol.Grammar.html#longlen/0","title":"Tds.Protocol.Grammar.longlen/0","type":"macro"},{"doc":"A signed 8-byte (64-bit) value.\n\nThe range is –(2^63) to (2^63)-1.","ref":"Tds.Protocol.Grammar.html#longlong/0","title":"Tds.Protocol.Grammar.longlong/0","type":"macro"},{"doc":"An unsigned single byte (8-bit) value representing the precision of a\nnumeric number.","ref":"Tds.Protocol.Grammar.html#precision/0","title":"Tds.Protocol.Grammar.precision/0","type":"macro"},{"doc":"An unsigned single byte (8-bit) value representing the scale of a\nnumeric number.","ref":"Tds.Protocol.Grammar.html#scale/0","title":"Tds.Protocol.Grammar.scale/0","type":"macro"},{"doc":"An unsigned single byte (8-bit) value representing a character.\n\nThe range is 0 to 255.","ref":"Tds.Protocol.Grammar.html#uchar/1","title":"Tds.Protocol.Grammar.uchar/1","type":"macro"},{"doc":"An unsigned 4-byte (32-bit) value.\n\nThe range is 0 to (2^32)-1.","ref":"Tds.Protocol.Grammar.html#ulong/0","title":"Tds.Protocol.Grammar.ulong/0","type":"macro"},{"doc":"An unsigned 8-byte (64-bit) value.\n\nThe range is 0 to (2^64)-1.","ref":"Tds.Protocol.Grammar.html#ulonglong/0","title":"Tds.Protocol.Grammar.ulonglong/0","type":"macro"},{"doc":"An unsigned 8-byte (64-bit) value representing the length of the associated\ndata.\n\nThe range is 0 to (2^64)-1.","ref":"Tds.Protocol.Grammar.html#ulonglonglen/0","title":"Tds.Protocol.Grammar.ulonglonglen/0","type":"macro"},{"doc":"A single Unicode character in UCS-2 encoding, as specified in\n[Unicode](https://go.microsoft.com/fwlink/?LinkId=90550).","ref":"Tds.Protocol.Grammar.html#unicodechar/1","title":"Tds.Protocol.Grammar.unicodechar/1","type":"macro"},{"doc":"An unsigned 2-byte (16-bit) value.\n\nThe range is 0 to 65535.","ref":"Tds.Protocol.Grammar.html#ushort/0","title":"Tds.Protocol.Grammar.ushort/0","type":"macro"},{"doc":"An unsigned 2-byte (16-bit) value representing the length of the associated\ncharacter or binary data.\n\nThe range is 0 to 8000.","ref":"Tds.Protocol.Grammar.html#ushortcharbinlen/0","title":"Tds.Protocol.Grammar.ushortcharbinlen/0","type":"macro"},{"doc":"An unsigned 2-byte (16-bit) value representing the length of the associated\ndata.\n\nThe range is 0 to 65535.","ref":"Tds.Protocol.Grammar.html#ushortlen/0","title":"Tds.Protocol.Grammar.ushortlen/0","type":"macro"},{"doc":"Login7 message definition\n\nSee: https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-tds/773a62b6-ee89-4c02-9e5e-344882630aac","ref":"Tds.Protocol.Login7.html","title":"Tds.Protocol.Login7","type":"module"},{"doc":"","ref":"Tds.Protocol.Login7.html#encode/1","title":"Tds.Protocol.Login7.encode/1","type":"function"},{"doc":"","ref":"Tds.Protocol.Login7.html#new/1","title":"Tds.Protocol.Login7.new/1","type":"function"},{"doc":"Prelogin message definition\n\nSee: https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-tds/60f56408-0188-4cd5-8b90-25c6f2423868","ref":"Tds.Protocol.Prelogin.html","title":"Tds.Protocol.Prelogin","type":"module"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#decode/2","title":"Tds.Protocol.Prelogin.decode/2","type":"function"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#encode/1","title":"Tds.Protocol.Prelogin.encode/1","type":"function"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#t:packet_data/0","title":"Tds.Protocol.Prelogin.packet_data/0","type":"type"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#t:response/0","title":"Tds.Protocol.Prelogin.response/0","type":"type"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#t:state/0","title":"Tds.Protocol.Prelogin.state/0","type":"type"},{"doc":"","ref":"Tds.Protocol.Prelogin.html#t:t/0","title":"Tds.Protocol.Prelogin.t/0","type":"type"},{"doc":"TDS query encoding and decoding","ref":"Tds.Query.html","title":"Tds.Query","type":"module"},{"doc":"","ref":"Tds.Query.html#t:t/0","title":"Tds.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query.","ref":"Tds.Result.html","title":"Tds.Result","type":"module"},{"doc":"* `columns`: The column names.\n* `rows`: The result set as a list of tuples. Each tuple corresponds to a\n  row, while each element in the tuple corresponds to a column.\n* `num_rows`: The number of fetched or affected rows.","ref":"Tds.Result.html#module-fields","title":"Fields - Tds.Result","type":"module"},{"doc":"The result of a database query.","ref":"Tds.Result.html#t:t/0","title":"Tds.Result.t/0","type":"type"},{"doc":"UUID data type","ref":"Tds.Types.UUID.html","title":"Tds.Types.UUID","type":"module"},{"doc":"Generates a version 4 (random) UUID in the binary format.","ref":"Tds.Types.UUID.html#bingenerate/0","title":"Tds.Types.UUID.bingenerate/0","type":"function"},{"doc":"Casts to UUID.","ref":"Tds.Types.UUID.html#cast/1","title":"Tds.Types.UUID.cast/1","type":"function"},{"doc":"Same as `cast/1` but raises `Ecto.CastError` on invalid arguments.","ref":"Tds.Types.UUID.html#cast!/1","title":"Tds.Types.UUID.cast!/1","type":"function"},{"doc":"Converts a string representing a UUID into a binary.","ref":"Tds.Types.UUID.html#dump/1","title":"Tds.Types.UUID.dump/1","type":"function"},{"doc":"","ref":"Tds.Types.UUID.html#dump!/1","title":"Tds.Types.UUID.dump!/1","type":"function"},{"doc":"Generates a version 4 (random) UUID.","ref":"Tds.Types.UUID.html#generate/0","title":"Tds.Types.UUID.generate/0","type":"function"},{"doc":"Converts a binary UUID into a string.","ref":"Tds.Types.UUID.html#load/1","title":"Tds.Types.UUID.load/1","type":"function"},{"doc":"Utility functions for Tds","ref":"Tds.Utils.html","title":"Tds.Utils","type":"module"},{"doc":"","ref":"Tds.Utils.html#decode_chars/2","title":"Tds.Utils.decode_chars/2","type":"function"},{"doc":"Encodes given string to given codepage using configured encoder.\nDefaults to Tds.Encoding.Latin1 if none is configured","ref":"Tds.Utils.html#encode_chars/2","title":"Tds.Utils.encode_chars/2","type":"function"},{"doc":"","ref":"Tds.ConfigError.html","title":"Tds.ConfigError","type":"exception"},{"doc":"Defines the `Tds.Error` struct.\n\nThe struct has two fields:\n\n* `:message`: expected to be a string\n* `:mssql`: expected to be a keyword list with the fields `line_number`,\n            `number` and `msg_text`","ref":"Tds.Error.html","title":"Tds.Error","type":"exception"},{"doc":"iex> raise Tds.Error\n    ** (Tds.Error) An error occured.\n\n    iex> raise Tds.Error, \"some error\"\n    ** (Tds.Error) some error\n\n    iex> raise Tds.Error, line_number: 10, number: 8, msg_text: \"some error\"\n    ** (Tds.Error) Line 10 (8): some error","ref":"Tds.Error.html#module-usage","title":"Usage - Tds.Error","type":"exception"},{"doc":"","ref":"Tds.Error.html#get_constraint_violations/2","title":"Tds.Error.get_constraint_violations/2","type":"function"},{"doc":"","ref":"Tds.Error.html#t:error_details/0","title":"Tds.Error.error_details/0","type":"type"},{"doc":"","ref":"Tds.Error.html#t:t/0","title":"Tds.Error.t/0","type":"type"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-4-2023-09-02","title":"v2.3.4 (2023-09-02) - Changelog","type":"extras"},{"doc":"* Add set_cursor_close_on_commit connection parameter\n* Support per connection execution_mode settings\n* Support Table.Reader protocol","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-3-2023-05-03","title":"v2.3.3 (2023-05-03) - Changelog","type":"extras"},{"doc":"* Add support for image parameter and column type","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-2-2022-10-04","title":"v2.3.2 (2022-10-04) - Changelog","type":"extras"},{"doc":"* Fix error on redirect request from the server #140 (Thanks @zerobatu)","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-1-2022-07-08","title":"v2.3.1 (2022-07-08) - Changelog","type":"extras"},{"doc":"* Add `:ssl` to `extra_applications`\n* Fix message handling for TCP / SSL errors\n* Don't redact password before login handshake is done","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"* No changes since v2.3.0-rc.1","ref":"changelog.html#v2-3-0-2021-12-08","title":"v2.3.0 (2021-12-08) - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-0-rc-1-2021-11-24","title":"v2.3.0-rc.1 (2021-11-24) - Changelog","type":"extras"},{"doc":"* Add `:crypto` to `extra_applications`\n* Fix missing `UCS.from_string` for list inputs","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-3-0-rc-0-2021-11-24","title":"v2.3.0-rc.0 (2021-11-24) - Changelog","type":"extras"},{"doc":"* Add initial support for SSL / TLS connections","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-2-0-2021-10-12","title":"v2.2.0 - 2021-10-12 - Changelog","type":"extras"},{"doc":"* Update `tds_encoding` to work with Erlang/OTP >= 24\n\n#","ref":"changelog.html#bugfix","title":"BugFix - Changelog","type":"extras"},{"doc":"* Add support for `decimal` 2.0 (minimal version is now 1.9)","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-1-3-2020-12-03","title":"v2.1.3 - 2020-12-03 - Changelog","type":"extras"},{"doc":"* Values in `datetimeoffset(n)` columns were failing to decode on match error due to offset unit mismatch (seconds != minutes).\n* Values in `datetimeoffset(n)` columns of non-UTC timezones were not encoded/decoded correctly.","ref":"changelog.html#bugfix","title":"BugFix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-1-2-2020-12-03","title":"v2.1.2 - 2020-12-03 - Changelog","type":"extras"},{"doc":"* Resolves [PR #115](https://github.com/livehelpnow/tds/pull/115). Thank you, [Chris Martin](https://github.com/trbngr)\n* Fix double incrementing of the packet number [PR #117](https://github.com/livehelpnow/tds/pull/117). Thank you, [DJ Jani](https://github.com/deepankar-j)","ref":"changelog.html#bugfix","title":"BugFix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-1-1-2020-06-14","title":"v2.1.1 - 2020-06-14 - Changelog","type":"extras"},{"doc":"* As per discussion [here](https://github.com/livehelpnow/tds/issues/108) exposed\n`Tds.query_multi/4` that should return complete resultset rather than single `%Tds.Result{}`\nso one can run multiple batches in single statement","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-1-0-2020-03-21","title":"v2.1.0 - 2020-03-21 - Changelog","type":"extras"},{"doc":"* ColMetadata token that contains XML schema_info now is parsed correctly.\n\n#","ref":"changelog.html#bugfix","title":"BugFix - Changelog","type":"extras"},{"doc":"* Improved compatibility with `ecto_sql` TDS adapter\n* Removed `Tds.Types.VarChar`. From now `ecto_sql` implements `Tds.Ecto.VarChar` that should be used in\nfields if schema requires it.\n* `Tds.Type.UUID` is moved to `ecto_sql` please use `Tds.Ecto.UUID` instead if you are using ecto.\n* `Tds.generate_uuid/0` is added so users can generate valid binary MS UUIDS,\nthere is also `Tds.decode_uuid/1` that should help parsing MS UUID binary to its string representation\n* `sp_execute` is now using **PROCID** in protocol so message size is reduced for few bytes\n* In explicit transactions (`Tds.transaction/2`) now you can tell transaction manager what isolation level you need.\nYou are encouraged to use this instead of `SET TRANSACTION ISOLATION LEVEL ...` due:\n  - Less round trips to database (saving 3 RPC calls)\n  - Less bytes are sent over wire since all is in single transaction manager call\n  - snapshot isolation level works in combination with connection settings `set_allow_snapshot_isolation: :on`\n* Elixir calendar types are supported if connection is configured with `use_elixir_calendar_types: true`,\ncolumns that are of SQL types `SmallDateTime`, `DateTime`, `DateTime2`, `DateTimeOffset`, `Time` and `Date` will be\ndecoded into elixir `NaiveDateTime`, `DateTime`, `Time` and `Date`. If this flag is not set to connection tuples will be used.\n* Rustler dependency is not mandatory anymore. Requirements are moved to `tds_encoding` library. If you need non latin1 encoding\nfor your varchars please add this library to your dependency and add in configuration `config :tds, :text_encoder, Tds.Encoding`","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-0-1-rc1-2020-02-03","title":"v2.0.1-rc1 - 2020-02-03 - Changelog","type":"extras"},{"doc":"In order to improve compatibility with `ecto_sql`, following breaking changes are introduced in this release:\n* Since `tds_ecto` package is deprecated and adapter is moving to `ecto_sql`, use `Tds.Types.UUID` for\ncolumn types `binary_id` (`uuid`).\n* For same reason as above `Tds.VarChar` is now `Tds.Types.VarChar`\n* If you are using collation other than Latin1 please add dependency to `:tds_encoding` package and following instructions\nin readme on how to configure tds to use this encoder.","ref":"changelog.html#breaking-changes","title":"Breaking changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v2-0-0-2018-11-18","title":"v2.0.0 - 2018-11-18 - Changelog","type":"extras"},{"doc":"* Implements DBConnection v2.0 to support `ecto_sql`. Please note that starting from this version [tds_ecto](https://hex.pm/packages/tds_ecto) is not improved anymore and will not use tds version 2.0.0+, instead use [ecto_sql](https://hex.pm/packages/ecto_sql) where tds_ecto will become part of it starting from version 3.1.0.","ref":"changelog.html#improvements","title":"Improvements: - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-2-0-2019-07-31","title":"v1.2.0 - 2019-07-31 - Changelog","type":"extras"},{"doc":"- `char`, `nchar`, `text`, `ntext`, `varchar` and `nvarchar` encoding improvements\nfor most of the SQL collations. More will be supported.","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-1-7-2019-05-26","title":"v1.1.7 - 2019-05-26 - Changelog","type":"extras"},{"doc":"- Fix for \"Error with set_transaction_isolation_level: :read_uncommited\" [issue #72](https://github.com/livehelpnow/tds_ecto/issues/72)","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-1-5-2018-11-17","title":"v1.1.5 - 2018-11-17 - Changelog","type":"extras"},{"doc":"* Allow users to choose between `:prepare_execute` and `:executesql` style (PR #71) default is `:prepare_execute`\n* Fix unnecessary append of possibly large binaries #70\n#","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"* Unexpected Environment Change message kills the connection #72","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-1-4-2018-07-10","title":"v1.1.4 - 2018-07-10 - Changelog","type":"extras"},{"doc":"* Adding `sp_unprepare` after SQL statement is executed.\n\n# v1.1.3 - 2018-06-11\n#","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"* Improving traceability. Adding hostname and application/program name to login7 tds package so one could easier trace rpc calls in SQL Server. Program name is equal to FQ erlang node name, while hostname is what ever :inet.gethostname() returns. May fail to connect if `:inet` is unable to read hostname.","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-1-2-2018-05-04","title":"v1.1.2 - 2018-05-04 - Changelog","type":"extras"},{"doc":"* Float loses precision. Fix will force floats to be encoded as 64bit floats and param type as float(53) in order to keep all bits\n* Fix for: Rollback is called twice on failure in explicit transaction. (DBConnection [mode: :savepoint] support)","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-1-0-2018-04-30","title":"v1.1.0 - 2018-04-30 - Changelog","type":"extras"},{"doc":"UUID/UNIQUEIDENTIFER column is now stored AS IS in database, meaning that compatibility with Ecto.UUID is broken,\nif you are using `tds_ecto` please use Tds.UUID to encode/decode value to its sting representation. MSSQL has its way of\nparsing binary UUID value into string representation as following string illustration:\n\n  Ecto.UUID string representation:\n  `f72f71ce-ee18-4db3-74d9-f5662a7691b8`\n\n  MSSQL string representation:\n  `ce712ff7-18ee-b34d-74d9-f5662a7691b8`\n\nTo allow other platforms to interpret correctly uuids we had to introduce\n`Tds.UUID` in `tds_ecto` library and `Tds.Types.UUID` in `tds` both are trying to\nkeep binary storage in valid byte order so each platform can correctly decode it into string.\nSo far unique identifiers were and will be returned in resultset as binary, if you need to convert it into\nformatted string, use `Tds.Types.UUID.parse( >=uuid)` to get that string.\nIt is safe to call this function several times since it will not fail if value is valid uuid string,\nit will just return same value. But if value do not match ` >` or\n` >` it will throw runtime error.\n\nIf you are using `tds_ecto` :uuid, :binary_id, and Tds.UUID are types you want to use in your models.\nFor any of those 3 types auto encode/decode will be performed.\n\nSince there was a bug where in some cases old version of `tds_ecto` library\ncould not determine if binary is of uuid type, it interpreted such values as raw binary which caused some issues when non elixir apps interpreted that binary in wrong string format. This was ok as long as parsed string values were not shared between elixir and other platforms trough e.g. JSON messages, but if they did, this could be a problem where other app is not capable to find object which miss parsed uuid value.","ref":"changelog.html#breaking-changes","title":"Breaking Changes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-18-2018-04-15","title":"v1.0.18 - 2018-04-15 - Changelog","type":"extras"},{"doc":"* Fixing missing case when string/varchar length is between 2_000 and 4_000 characters long.","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-17-2018-04-11","title":"v1.0.17 - 2018-04-11 - Changelog","type":"extras"},{"doc":"* Fix for SET TRANSACTION_ISOLATION_LEVEL issue","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-16-2018-03-27","title":"v1.0.16 - 2018-03-27 - Changelog","type":"extras"},{"doc":"* exposing connection options such as:\n  * set_language - check stored procedure `sp_helplanguage` name column value should be used here\n  * set_datefirst - number in range `1..7`\n  * set_dateformat - atom `:mdy | :dmy | :ymd | :ydm | :myd | :dym`\n  * set_deadlock_priority - one of `:low | :high | :normal | -10..10`\n  * set_lock_timeout - number in milliseconds > 0\n  * set_remote_proc_transactions - atom :on | :off\n  * set_implicit_transactions - atom :on | :off\n  * set_transaction_isolation_level - atom :read_uncommited | :read_commited | :repeatable_read | :snapshot | :serializable\n  * set_allow_snapshot_isolation - atom :on | :off","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-15-2018-03-15","title":"v1.0.15 - 2018-03-15 - Changelog","type":"extras"},{"doc":"* Handle Azure redirecting to new host after env_change token on login #61","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-14-2018-02-27","title":"v1.0.14 - 2018-02-27 - Changelog","type":"extras"},{"doc":"* Parameters `:string`, `:varchar` and `:binary` are encoded as `nvarchar(max)`, `varchar(max)` and `varbinary(max)` when string or binary length is greater than 2000, otherwise `nvarchar(2000)`, `varchar(2000)` and `varbinary(2000)`. This change is added to avoid aggressive execution plan caching on SQL Server since parameters may often vary in length, so SQL server will makes execution plan for each parameter length case.","ref":"changelog.html#improvements","title":"Improvements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-13-2018-02-15","title":"v1.0.13 - 2018-02-15 - Changelog","type":"extras"},{"doc":"* issue #62 fixing info message token parsing","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-12-2018-01-26","title":"v1.0.12 - 2018-01-26 - Changelog","type":"extras"},{"doc":"* issue #59 fixing login error when database name contains special characters like \"-\"","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-11-2017-12-08","title":"v1.0.11 - 2017-12-08 - Changelog","type":"extras"},{"doc":"* fixing issue with done in proc token when stored pcedure is executed","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-10-2017-12-03","title":"v1.0.10 - 2017-12-03 - Changelog","type":"extras"},{"doc":"* fixing negative integer/bigint encoding","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-9-2017-12-02","title":"v1.0.9 - 2017-12-02 - Changelog","type":"extras"},{"doc":"* Removing obsolete reply function which causing error when connection can not be established to server","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-8-2017-12-01","title":"v1.0.8 - 2017-12-01 - Changelog","type":"extras"},{"doc":"* Fixing handle 0 error","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-7-2017-11-25","title":"v1.0.7 - 2017-11-25 - Changelog","type":"extras"},{"doc":"* Ping timout caused process to crash","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-6-2017-11-24","title":"v1.0.6 - 2017-11-24 - Changelog","type":"extras"},{"doc":"* Double precision floats fix","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-5-2017-11-22","title":"v1.0.5 - 2017-11-22 - Changelog","type":"extras"},{"doc":"* StaleEntity error fix when row is inserted into table and done token is incorrectly parsed\n  * fixing resultset order","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v1-0-3-2017-10-06","title":"v1.0.3 - 2017-10-06 - Changelog","type":"extras"},{"doc":"* When insert is performed with output incorrect row count is calculated. Causing tds_ecto and ecto to think it is StaleEntity","ref":"changelog.html#bugfix","title":"Bugfix - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-4-2016-01-15","title":"v0.5.4 - 2016-01-15 - Changelog","type":"extras"},{"doc":"* Cleaned up code style for Elixir 1.2.0 warnings","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-3-2015-10-23","title":"v0.5.3 - 2015-10-23 - Changelog","type":"extras"},{"doc":"* Loosen Elixir dependency","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-2-2015-09-24","title":"v0.5.2 - 2015-09-24 - Changelog","type":"extras"},{"doc":"* If server outputs warning result rows are missing.","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-5-1-2015-07-22","title":"v0.5.1 - 2015-07-22 - Changelog","type":"extras"},{"doc":"* Added token decoder for return status of RPC","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Backwards Incompatible Changes\n  * Rows now return as list instead of tuple","ref":"changelog.html#v0-5-0-2015-07-10","title":"v0.5.0 - 2015-07-10 - Changelog","type":"extras"},{"doc":"* Backwards Incompatible Changes\n  * datetime tuples are now {{year,month,day},{hour,min,sec,usec}}","ref":"changelog.html#v0-4-0-2015-07-07","title":"v0.4.0 - 2015-07-07 - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-3-0-2015-06-26","title":"v0.3.0 - 2015-06-26 - Changelog","type":"extras"},{"doc":"* Added parameter encoding support for datetime2\n  * Removed dependency on Timex","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-8-2015-06-25","title":"v0.2.8 - 2015-06-25 - Changelog","type":"extras"},{"doc":"* Fixed issue where tail would time out queries randomly","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-7-2015-06-04","title":"v0.2.7 - 2015-06-04 - Changelog","type":"extras"},{"doc":"* Added ability to pass socket options to connect.\n  * Set internal socket buffer.","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-6-2015-04-25","title":"v0.2.6 - 2015-04-25 - Changelog","type":"extras"},{"doc":"* Fixed issue where messages spanning multiple packets might not finish","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-5-2015-04-08","title":"v0.2.5 - 2015-04-08 - Changelog","type":"extras"},{"doc":"* Enum error when calling ATTN on server","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-4-2015-03-26","title":"v0.2.4 - 2015-03-26 - Changelog","type":"extras"},{"doc":"* Added support for DateTimeOffset\n  * Updated Deps","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-3-2015-03-20","title":"v0.2.3 - 2015-03-20 - Changelog","type":"extras"},{"doc":"* Added Long Length decoder support for text, ntext and image\n  * Fixed PLP decode / Encode for sending and receiving large test\n  * Fixed issue where selecting from NTEXT, TEXT, NVARCHAR(MAX), VARCHAR(MAX) would trunc to 4kb","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-2-2015-03-09","title":"v0.2.2 - 2015-03-09 - Changelog","type":"extras"},{"doc":"* Fixed udp port scope for instances","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-1-2015-03-09","title":"v0.2.1 - 2015-03-09 - Changelog","type":"extras"},{"doc":"* Fixed: Packets sent to the server which exceed the negotiated packet size would cause the connection to close\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Added support for decoding Time(n) and DateTime2\n  * Added support for SQL Named Instances, pass instance: \"instance_name\" in connection options","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-2-0-2015-03-04","title":"v0.2.0 - 2015-03-04 - Changelog","type":"extras"},{"doc":"* Added SET defaults upon connection of:\n    SET ANSI_NULLS ON;\n    SET QUOTED_IDENTIFIER ON;\n    SET CURSOR_CLOSE_ON_COMMIT OFF;\n    SET ANSI_NULL_DFLT_ON ON;\n    SET IMPLICIT_TRANSACTIONS OFF;\n    SET ANSI_PADDING ON;\n    SET ANSI_WARNINGS ON;\n    SET CONCAT_NULL_YIELDS_NULL ON;\n\n#","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"* Fixed issue with empty strings and binaries being converted to nil\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* datetime2 with 0 usec's will be transmitted as datetime\n\n* Backwards incompatable changes\n  * Changed datetime to be passed back as {{year, month, day} ,{hour, min, sec, microsec}}","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-6-2015-02-25","title":"v0.1.6 - 2015-02-25 - Changelog","type":"extras"},{"doc":"* Changed default connection timeout to 5000 from :infinity\n  * Added caller pid monitoring to cancel query if caller dies\n  * Call ATTN if the caller who dies is the currently executing query\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Added API for ATTN call\n\n<<<<<<< HEAD","ref":"changelog.html#enhancements","title":"Enhancements - Changelog","type":"extras"},{"doc":"=======","ref":"changelog.html#v0-1-5","title":"v0.1.5 - Changelog","type":"extras"},{"doc":">>>>>>> 1007dc1 (Misc doc changes)\n#","ref":"changelog.html#v0-1-5-2015-02-19","title":"v0.1.5 - 2015-02-19 - Changelog","type":"extras"},{"doc":"* Fixed issue where driver would not call Connection.next when setting the state to :ready\n  * Fixed UCS2 Encoding","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-4-2015-02-16","title":"v0.1.4 - 2015-02-16 - Changelog","type":"extras"},{"doc":"* Fixed encoding for integers","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-3-2015-02-12","title":"v0.1.3 - 2015-02-12 - Changelog","type":"extras"},{"doc":"* Removed Timer from queued commands.\n  * Changed error handling to error func","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-2-2015-02-12","title":"v0.1.2 - 2015-02-12 - Changelog","type":"extras"},{"doc":"* Adding missing date time decoders\n  * Compatibility updates for ecto","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#v0-1-1-2015-02-02","title":"v0.1.1 - 2015-02-02 - Changelog","type":"extras"},{"doc":"* Fixed issue with Bitn always returning true\n  * Fixed missing data return for char data decoding\n  * Added float encoders\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Cleaned up logger functions","ref":"changelog.html#general","title":"General - Changelog","type":"extras"},{"doc":"* First Release","ref":"changelog.html#v0-1-0-2015-02-02","title":"v0.1.0 - 2015-02-02 - Changelog","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"# Tds - MSSQL Driver for Elixir\n\n[![Hex.pm](https://img.shields.io/hexpm/v/tds.svg)](https://hex.pm/packages/tds)\n![Elixir TDS CI](https://github.com/elixir-ecto/tds/workflows/Elixir%20TDS%20CI/badge.svg)\n\nMSSQL / TDS Database driver for Elixir.\n\n#","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Since TDS version 2.0, `tds_ecto` package is deprecated, this version supports `ecto_sql` since version 3.3.4.\n\nPlease check out the issues for a more complete overview. This branch should not be considered stable or ready for production yet.\n\nFor stable versions always use [hex.pm](https://hex.pm/packages/tds) as source for your mix.exs.","ref":"readme.html#note","title":"NOTE: - Overview","type":"extras"},{"doc":"Add `:tds` as a dependency in your `mix.exs` file.\n\n```elixir\ndef deps do\n  [\n    {:tds, \"~> 2.3\"}\n  ]\nend\n```\n\nAs of TDS version `>= 1.2`, tds can support windows codepages other than `windows-1252` (latin1).\nIf you need such support you will need to include additional dependency `{:excoding, \"~> 0.1\"}`\nand configure `:tds` app to use `Excoding` module like this:\n\n\n```elixir\nimport Mix.Config\n\nconfig :tds, :text_encoder, Excoding\n```\n\nWhen you are done, run `mix deps.get` in your shell to fetch and compile Tds.\nStart an interactive Elixir shell with `iex -S mix`.\n\n```elixir\niex> {:ok, pid} = Tds.start_link([hostname: \"localhost\", username: \"test_user\", password: \"test_password\", database: \"test_db\", port: 4000])\n{:ok, #PID }\n\niex> Tds.query!(pid, \"SELECT 'Some Awesome Text' AS MyColumn\", [])\n%Tds.Result{columns: [\"MyColumn\"], rows: [{\"Some Awesome Text\"}], num_rows: 1}}\n\niex> Tds.query!(pid, \"INSERT INTO MyTable (MyColumn) VALUES (@my_value)\",\n...> [%Tds.Parameter{name: \"@my_value\", value: \"My Actual Value\"}])\n%Tds.Result{columns: nil, rows: nil, num_rows: 1}}\n```","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":"* Automatic decoding and encoding of Elixir values to and from MSSQL's binary format\n* Support of TDS Versions 7.3, 7.4","ref":"readme.html#features","title":"Features - Overview","type":"extras"},{"doc":"Example configuration\n\n```elixir\nimport Mix.Config\n\nconfig :your_app, :tds_conn,\n  hostname: \"localhost\",\n  username: \"test_user\",\n  password: \"test_password\",\n  database: \"test_db\",\n  port: 1433\n```\n\nThen using `Application.get_env(:your_app, :tds_conn)` use this as first parameter in `Tds.start_link/1` function.\n\nThere is additional parameter that can be used in configuration and\ncan improve query execution in SQL Server. If you find out that\nyour queries suffer from \"density estimation\" as described [here](https://www.brentozar.com/archive/2018/03/sp_prepare-isnt-good-sp_executesql-performance/)\n\nYou can try switching how tds executes queries as below:\n\n```elixir\nimport Mix.Config\n\nconfig :your_app, :tds_conn,\n  hostname: \"localhost\",\n  username: \"test_user\",\n  password: \"test_password\",\n  database: \"test_db\",\n  port: 1433,\n  execution_mode: :executesql\n```\nThis will skip calling `sp_prepare` and query will be executed using `sp_executesql` instead.\nPlease note that only one execution mode can be set at a time, and SQL Server will probably\nuse single execution plan (since it is NOT estimated by checking data density!).","ref":"readme.html#configuration","title":"Configuration - Overview","type":"extras"},{"doc":"tds `>= 2.3.0` supports encrypted connections to the SQL Server.\n\nThe following encryption behaviours are currently supported:\n\n- `:required`: Requires the server to use TLS\n- `:on`: Same as required\n- `:not_supported`: Indicates to the server that encryption is not supported. If server requires encryption, the connection will not be established.\n\nCurrently not supported:\n\n- `:off`: This setting allows the server to upgrade the connection (if server encryption is `:on` or `:required`) and only encrypts the LOGIN packet when the server has encryption set to `:off`.\n- `:client_cert`: This will make the server check the client cerfiticate.\n\nSetting `ssl: true` or `ssl: false` is also allowed. In that case `true` is mapped to `:required` and `false` to `:not_supported`.\n\n```elixir\nconfig :your_app, :tds_conn,\n  hostname: \"localhost\",\n  username: \"test_user\",\n  password: \"test_password\",\n  database: \"test_db\",\n  ssl: :required,\n  port: 1433,\n  execution_mode: :executesql\n\n```","ref":"readme.html#ssl-tls-support","title":"SSL / TLS support - Overview","type":"extras"},{"doc":"Tds supports SQL Server instances by passing `instance: \"instancename\"` to the connection options.\nSince v1.0.16, additional connection parameters are:\n  - `:set_language` - check stored procedure output `exec sp_helplanguage` name column value should be used here\n  - `:set_datefirst` - number in range `1..7`\n  - `:set_dateformat` - atom, one of `:mdy | :dmy | :ymd | :ydm | :myd | :dym`\n  - `:set_deadlock_priority` - atom, one of `:low | :high | :normal | -10..10`\n  - `:set_lock_timeout` - number in milliseconds > 0\n  - `:set_remote_proc_transactions` - atom, one of `:on | :off`\n  - `:set_implicit_transactions` - atom, one of `:on | :off`\n  - `:set_transaction_isolation_level` - atom, one of `:read_uncommitted | :read_committed | :repeatable_read | :snapshot | :serializable`\n  - `:set_allow_snapshot_isolation` - atom, one of `:on | :off`\n  - `:set_cursor_close_on_commit` - atom, one of `:on | :off`\n  - `:set_read_committed_snapshot` - atom, one of `:on | :off`\n\nSet this option to enable snapshot isolation on the database level.\nRequires connecting with a user with appropriate rights.\nMore info [here](https://docs.microsoft.com/en-us/dotnet/framework/data/adonet/sql/snapshot-isolation-in-sql-server).","ref":"readme.html#connecting-to-sql-server-instances","title":"Connecting to SQL Server Instances - Overview","type":"extras"},{"doc":"This Authentication mechanism is not supported.\nThis functionality requires specific environment to be developed.","ref":"readme.html#federation-authentication","title":"Federation Authentication - Overview","type":"extras"},{"doc":"| TDS               | Elixir                                                                                     |\n| ----------------- | ------------------------------------------------------------------------------------------ |\n| NULL              | nil                                                                                        |\n| bool              | true / false                                                                               |\n| char              | \"é\"                                                                                        |\n| int               | 42                                                                                         |\n| float             | 42.0                                                                                       |\n| text              | \"text\"                                                                                     |\n| binary            |  >                                                                                     |\n| numeric           | #Decimal                                                                              |\n| date              | {2013, 10, 12} or %Date{}                                                                  |\n| time              | {0, 37, 14} or {0, 37, 14, 123456} or %Time{}                                              |\n| smalldatetime     | {{2013, 10, 12}, {0, 37, 14}} or {{2013, 10, 12}, {0, 37, 14, 123456}}                     |\n| datetime          | {{2013, 10, 12}, {0, 37, 14}} or {{2013, 10, 12}, {0, 37, 14, 123456}} or %NaiveDateTime{} |\n| datetime2         | {{2013, 10, 12}, {0, 37, 14}} or {{2013, 10, 12}, {0, 37, 14, 123456}} or %NaiveDateTime{} |\n| datetimeoffset(n) | {{2013, 10, 12}, {0, 37, 14}} or {{2013, 10, 12}, {0, 37, 14, 123456}} or %DateTime{}      |\n| uuid              |  >                             |\n\nCurrently unsupported: [User-Defined Types](https://docs.microsoft.com/en-us/sql/relational-databases/clr-integration-database-objects-user-defined-types/working-with-user-defined-types-in-sql-server), XML\n\n#","ref":"readme.html#data-representation","title":"Data representation - Overview","type":"extras"},{"doc":"Tds can work with dates and times in either a tuple format or as Elixir calendar types. Calendar types can be enabled in the config with `config :tds, opts: [use_elixir_calendar_types: true]`.\n\n**Tuple forms:**\n\n- Date: `{yr, mth, day}`\n- Time: `{hr, min, sec}` or `{hr, min, sec, fractional_seconds}`\n- DateTime: `{date, time}`\n- DateTimeOffset: `{utc_date, utc_time, offset_mins}`\n\nIn SQL Server, the `fractional_seconds` of a `time`, `datetime2` or `datetimeoffset(n)` column can have a precision of 0-7, where the `microsecond` field of a `%Time{}` or `%DateTime{}` struct can have a precision of 0-6.\n\nNote that the DateTimeOffset tuple expects the date and time in UTC and the offset in minutes. For example, `{{2020, 4, 5}, {5, 30, 59}, 600}` is equal to `'2020-04-05 15:30:59+10:00'`.\n\n#","ref":"readme.html#dates-and-times","title":"Dates and Times - Overview","type":"extras"},{"doc":"[MSSQL stores UUIDs in mixed-endian\nformat](https://dba.stackexchange.com/a/121878), and these mixed-endian UUIDs\nare returned in [Tds.Result](https://hexdocs.pm/tds/Tds.Result.html).\n\nTo convert a mixed-endian UUID binary to a big-endian string, use\n[Tds.Types.UUID.load/1](https://hexdocs.pm/tds/Tds.Types.UUID.html#load/1)\n\nTo convert a big-endian UUID string to a mixed-endian binary, use\n[Tds.Types.UUID.dump/1](https://hexdocs.pm/tds/Tds.Types.UUID.html#dump/1)","ref":"readme.html#uuids","title":"UUIDs - Overview","type":"extras"},{"doc":"Clone and compile Tds with:\n\n```bash\ngit clone https://github.com/elixir-ecto/tds.git\ncd tds\nmix deps.get\n```\n\nYou can test the library with `mix test`. Use `mix credo` for linting and\n`mix dialyzer` for static code analysis. Dialyzer will take a while when you\nuse it for the first time.\n\n#","ref":"readme.html#contributing","title":"Contributing - Overview","type":"extras"},{"doc":"The tests require an SQL Server database to be available on localhost.\nIf you are not using Windows OS you can start sql server instance using Docker.\nOfficial SQL Server Docker image can be found [here](https://hub.docker.com/r/microsoft/mssql-server-linux).\n\nIf you do not have specific requirements on how you would like to start sql server\nin docker, you can use script for this repo.\n\n```bash\n$ ./docker-mssql.sh\n```\n\nIf you prefer to install SQL Server directly on your computer, you can find\ninstallation instructions here:\n\n* [Windows](https://docs.microsoft.com/en-us/sql/database-engine/install-windows/install-sql-server-from-the-installation-wizard-setup)\n* [Linux](https://docs.microsoft.com/en-us/sql/linux/sql-server-linux-setup)\n\nMake sure your SQL Server accepts the credentials defined in `test/test_helper.exs`.\n\nYou also will need to have the *sqlcmd* command line tools installed. Setup\ninstructions can be found here:\n\n* [Linux](https://docs.microsoft.com/en-us/sql/linux/sql-server-linux-setup-tools)\n* [macOS](https://docs.microsoft.com/en-us/sql/connect/odbc/linux-mac/install-microsoft-odbc-driver-sql-server-macos)","ref":"readme.html#development-sql-server-setup","title":"Development SQL Server Setup - Overview","type":"extras"},{"doc":"Thanks to [ericmj](https://github.com/ericmj), this driver takes a lot of inspiration from postgrex.\n\nAlso thanks to everyone in the Elixir Google group and on the Elixir IRC Channel.","ref":"readme.html#special-thanks","title":"Special Thanks - Overview","type":"extras"},{"doc":"Copyright (c) 2015 LiveHelpNow\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [https://www.apache.org/licenses/LICENSE-2.0](https://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}]}